// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import eu.etaxonomy.cdm.api.service.config.IIdentifiableEntityServiceConfigurator;
import eu.etaxonomy.cdm.api.service.config.IdentifiableServiceConfiguratorFactory;
import eu.etaxonomy.cdm.model.common.IdentifiableEntity;

/**
 * @author n.hoffmann
 * @created Dec 14, 2010
 * @version 1.0
 */
public class BulkEditorQuery {

	private final String searchString;
	private final Comparator<?> comparator;
	private final IIdentifiableEntityServiceConfigurator searchConfigurator;

	public BulkEditorQuery (String searchString, Comparator comparator) {
		this.searchString = searchString;
		this.comparator = comparator;
		List<String> propertyPath = new ArrayList<String>();
		propertyPath.add("markers");
		searchConfigurator = IdentifiableServiceConfiguratorFactory.getConfigurator(IdentifiableEntity.class);
		searchConfigurator.setTitleSearchString(searchString);
		searchConfigurator.setMatchMode(null);
		searchConfigurator.setPropertyPaths(propertyPath);

		if(searchString != null && searchString.trim().equals("*")){
			searchConfigurator.setPageSize(1000);
		}

	}

	public Comparator getComparator() {
		return comparator;
	}

	public String getSearchString() {
		return searchString;
	}

	public IIdentifiableEntityServiceConfigurator getSearchConfigurator() {
		return searchConfigurator;
	}
}
