// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.input.entitycreator;

import java.util.HashMap;
import java.util.Map;

import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator;
import eu.etaxonomy.taxeditor.parser.ParseHandler;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * <p>NameCreator class.</p>
 *
 * @author p.ciardelli
 * @created 07.07.2009
 * @version 1.0
 */
public class NameCreator implements IEntityCreator<TaxonNameBase> {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityCreator#createEntity(java.lang.String)
	 */
	/** {@inheritDoc} */
	public TaxonNameBase createEntity(String text) {
		TaxonNameBase name = PreferencesUtil.getPreferredNomenclaturalCode().getNewTaxonNameInstance(null);
		name.setTitleCache(text, true);
		//name.setTitleCache(text);
		return name;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#createEntity(java.lang.Class, java.lang.String)
	 */
	/** {@inheritDoc} */
	public TaxonNameBase createEntity(Object key, String text) {
		return ParseHandler.parseName(text, (Rank) key);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#getClassLabelPairs()
	 */
	/**
	 * <p>getKeyLabelPairs</p>
	 *
	 * @return a {@link java.util.Map} object.
	 */
	public Map<Object, String> getKeyLabelPairs() {
		Map<Object, String> result = new HashMap<Object, String>();
		for (Rank rank : CdmStore.getTermManager().getPreferredTerms(Rank.class)) {
			result.put(rank, rank.getLabel());
		}
		return result;
	}

	@Override
	public boolean savesEntity() {
		// TODO Auto-generated method stub
		return false;
	}
}
