package eu.etaxonomy.taxeditor.bulkeditor.input.entitycreator;

import java.util.HashMap;
import java.util.Map;

import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.agent.Team;
import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class TaxonCreator implements IEntityCreator<TaxonBase>{

	NameCreator nameCreator;
	@Override
	public TaxonBase createEntity(String text) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public TaxonBase createEntity(Object key, String text) {
		TaxonBase taxonBase = null;
		if (nameCreator == null){
			nameCreator = new NameCreator();
		}
		if (Synonym.class.equals(key)){
			taxonBase = Synonym.NewInstance(nameCreator.createEntity(null, text), null);
		} else{
			taxonBase = Taxon.NewInstance(nameCreator.createEntity(null, text), null);
		}
		
		return taxonBase;
	}

	@Override
	public Map<Object, String> getKeyLabelPairs() {
		Map<Object, String> result = new HashMap<Object, String>();
		result.put(Synonym.class, "Synonym");
		result.put(Taxon.class, "Taxon");
		return result;
	}

	@Override
	public boolean savesEntity() {
		// TODO Auto-generated method stub
		return false;
	}

}
